#!/usr/local/bin/perl
# VRML STATISTICS
# version 1.0
# (C)Kenichi MATSUI (matsui@computer.org)
# 14/Mar/2000

########  
######## 
########
%def_titles = ("comment", "VRML STATISTICS version 0.1 (C) Kenichi MATSUI (matsui\@nemoto.ecei.tohoku.ac.jp) 18/Oct/1996",
	       "comment2","VRML STATISTICS version 0.1 18/Oct/1996",
	       "background", "0 0 0",
	       "viewer", "walk",
	       "title", "VRML STATISTICS v0.1",
	       "speed", "10"
	       );

@times = ("00","01","02","03","04","05","06","07","08","09","10","11",
	 "12","13","14","15","16","17","18","19","20","21","22","23");
%month = ("Jan", "1",
	  "Feb", "2",
	  "Mar", "3",
	  "Apr", "4",
	  "May", "5",
	  "Jun", "6",
	  "Jul", "7",
          "Aug", "8",
	  "Sep", "9",
	  "Oct", "10",
	  "Nov", "11",
	  "Dec", "12");

########
######## ѥ᡼
########
$count = 0;
$day_times = 24;
$x_times = 3;
$z_times = 5;
$y_times = 0.1 ;

$z_max = ($day_times -1)*$z_times;

$x_line = 30;
$cube_width = 0.1;
$cube_height = 30;

$height_tmp = $cube_height * 0.5;
$height_tmp_moji = $cube_height * 1.1;
$depth = ($day_times -1 ) * $z_times;
$depth_tmp = $depth * 0.5;
$z_max_tmp = $z_max * 0.5;
$z_max_cube = $z_max + 100;
$z_max_cube_tmp = $z_max_cube * 0.5;

$fontsize = 5;
$spacing = 3;

########
######## ե롢ȥץåȥե̾μ
########
if (($ARGV[0] eq "-h")||($ARGV[0] eq "-help")||($ARGV[0] eq "")){
    print "$def_titles{comment2}\n";
    print "Usage: vrmlstat logfile [outputfile]\n";
    exit;
}else{
    $access_log = "$ARGV[0]";
}
if ($ARGV[1] eq ""){
    $outputfile = "vrmlstat.wrl";
}else{
    $outputfile = "$ARGV[1]";
}
    
########
######## ץΤϤޤ
########
print "$def_titles{comment2}\n";
print "\tInput logfile: $access_log\n";
print "\tOutput vrmlfile: $outputfile\n\n";

########
######## ߻μ
########
local($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
        = localtime;
local($mname) = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
                     "Aug", "Sep", "Oct", "Nov", "Dec")[$mon];
local($dname) = ("Sun", "Mon", "Tue", "Wed", "Thu", "Fri",
                     "Sat")[$wday]; 
$mon++;

########
######## եβ
########
open(LOG,"$access_log")||die "Can't open $access_log\n\n";

print "Now calculating log file... \n";

while(<LOG>){
    @data = split(/[\[,:]/);
    ${$kekka{$data[1]}}{$data[2]}++;
    @daycalc = split(/\//,$data[1]);
    $calc = 0.001*$daycalc[0]+0.1*$month{$daycalc[1]}+$daycalc[2];
    $daysort{$calc} = $data[1];
}
close(LOG);

########
######## ˤ륽
########
@sortday = sort by_number keys(%daysort);

########
######## ϥեΥץ
########
open(OUT,">$outputfile")||die "Can't open $outputfile\n\n";
print "Now creating vrml file... \n";

######## 
######## VRMLեΥإå񤭹
######## 
&vrml_header(*def_titles);

######## 
######## ݥꥴν񤭹ߤΣ(Coordinate3point)
######## 
print OUT  <<EOFILE;
Separator {
    
    Material {
	diffuseColor 1 0 0
#	emissiveColor 1 0 0
	}
    Coordinate3 {
	point [
EOFILE

$x = -1;
$z = -1;

#foreach $a (sort keys %kekka){
foreach $dsort (@sortday){
    $a = $daysort{$dsort};
    $day_name{$x} = "$a";
    $x++;
#    foreach $b (sort keys %{$kekka{$a}}){
    foreach $b (sort @times){
	$x_tmp = $x;
	$x_tmp = $x_times*$x_tmp;
	$y = $y_times*${$kekka{$a}}{$b};
	$z = $z_times*$b;
	if(${$kekka{$a}}{$b} eq ""){
	print OUT  "$x_tmp 0 $z,\n";
    }else{
	print OUT  "$x_tmp $y $z,\n";
    }
    $count++;
}
}

print OUT  <<EOFILE;
0 0 0
]
}

EOFILE

######## 
######## ݥꥴν񤭹ߤΣ(IndexedFaceSetCoordIndex)
######## 
print OUT  <<EOFILE;

IndexedFaceSet {
    coordIndex [
EOFILE

for ($i = 0;$i<($count - $day_times - 1) ;$i++){
    $j = $i+1;
    $k_1 = $i+$day_times;
    $k_2 = $i - $day_times +1;
    if(( ($i+1) % $day_times) != 0){
        print OUT  "$i, $j, $k_1, -1,\n";
        if($k_2 > 0){
            print OUT  "$k_2, $j, $i, -1,\n";
        }
    }
}

    print OUT  "0, 0, 0, -1\n";

print OUT  <<EOFILE;
]
}

EOFILE


########
######## °ʤ(ġ褳ġʸ)
########

$x_max = $x * $x_times;
$half_x = $x_max * 0.5;
$x_over = $x_max * 1.2;
$x_over_half = $x_over * 0.5;
$x_over_moji = $x_over + 20;

######## 塼
%def_title1 = ("DEF","NONE",
	       "color","1 1 0",
	       "transp","0", 
	       "width","1",
	       "height","100",
	       "depth","1");
print OUT  <<EOFILE;
Separator {
    Transform {
	translation 0 50 0
	}
EOFILE
&Cube(*def_title1);
print OUT  "\}\n";

######## 
%def_title2 = ("DEF","NONE",
	       "color","1 1 0",
	       "transp","0",
	       "parts","ALL",
	       "bradius","5",
	       "height","10");
print OUT  <<EOFILE;
Separator {
    Transform {
	translation 0 100 0
	}
EOFILE
&Cone(*def_title2);
print OUT  "\}\n";
	       
######## 塼(Ƥܤ)
%def_title3 = ("DEF","TATEBOO",
	       "color","1 1 0",
	       "transp","0", 
	       "width","$x_over",
	       "height","1",
	       "depth","1");
print OUT  <<EOFILE;
Separator {
    Transform {
	translation $x_over_half 0 0
	}
EOFILE
&Cube(*def_title3);
print OUT  "\}\n";

######## 
%def_title4 = ("DEF","NONE",
	       "color","1 1 0",
	       "transp","0",
	       "parts","ALL",
	       "bradius","5",
	       "height","10");
    print OUT  <<EOFILE;
Separator {
    Transform {
	translation $x_over 0 0
	rotation 0 0 -1 1.570796
	}
EOFILE
    &Cone(*def_title4);
    print OUT  "\}\n";

######## ƥ(ACCESS)
%def_title5 = ("DEF","ACCESS",
	       "e_color","1 1 0",
	       "transp","0",
	       "size","25",
	       "family","SANS",
	       "style","BOLD",
	       "string","ACCESS",
	       "spacing","5",
	       "justi","CENTER",
	       "width","100");
    print OUT  <<EOFILE;
Separator {
    Transform {
	translation 0 120 0
	}
EOFILE
    &AsciiText(*def_title5);
    print OUT  "\}\n";

######## ƥ(DAY)
%def_title6 = ("DEF","DAY",
	       "e_color","1 1 0",
	       "transp","0",
	       "size","25",
	       "family","SANS",
	       "style","BOLD",
	       "string","DAY",
	       "spacing","1",
	       "justi","CENTER",
	       "width","50");
    print OUT  <<EOFILE;
Separator {
    Transform {
	translation $x_over_moji 0 0
	}
EOFILE
    &AsciiText(*def_title6);
    print OUT  "\}\n";

######## 塼 (Ƥܡ)
%def_title7 = ("DEF","TATEBOO",
	       "color","1 1 0",
	       "transp","0", 
	       "width","1",
	       "height","$cube_height",
	       "depth","1");
print OUT  <<EOFILE;
Separator {
    Transform {
	translation 0 $height_tmp 0
	}
EOFILE
&Cube(*def_title7);
print OUT  "\}\n";

######## 塼
%def_title8 = ("DEF","NONE",
	       "color","1 1 0",
	       "transp","0", 
	       "width","1",
	       "height","$z_max_cube",
	       "depth","1");
print OUT  <<EOFILE;
Separator {
    Transform {
	translation 0 0 $z_max_cube_tmp
	rotation 1 0 0 1.570796	    
	}
EOFILE
&Cube(*def_title8);
print OUT  "\}\n";

######## 
%def_title9 = ("DEF","Z_CONE",
	       "color","1 1 0",
	       "transp","0",
	       "parts","ALL",
	       "bradius","5",
	       "height","10");
    print OUT  <<EOFILE;
Separator {
    Transform {
	translation 0 0 $z_max_cube
	rotation 1 0 0 1.570796
	}
EOFILE
    &Cone(*def_title9);
    print OUT  "\}\n";

######## ƥ(HOUR)
%def_title10 = ("DEF","HOUR",
	       "e_color","1 1 0",
	       "transp","0",
	       "size","25",
	       "family","SANS",
	       "style","BOLD",
	       "string","HOUR",
	       "spacing","3",
	       "justi","RIGHT",
	       "width","100");
    print OUT  <<EOFILE;
Separator {
    Transform {
	translation 0 0 $z_max_cube
	}
EOFILE
    &AsciiText(*def_title10);
    print OUT  "\}\n";


######## 塼(褳)
%def_title11 = ("DEF","YOKOITA",
	       "color","0 0 1",
	       "transp","0.9", 
	       "width","$cube_width",
	       "height","$cube_height",
	       "depth","$depth");
print OUT  <<EOFILE;
Separator {
    Transform {
	translation 0 $height_tmp $depth_tmp
	}
EOFILE
&Cube(*def_title11);
print OUT  "\}\n";

######## 塼 (Ƥ)
%def_title12 = ("DEF","TATEITA",
	       "color","0 0 1",
	       "transp","0.9", 
	       "width","$x_max",
	       "height","$cube_height",
	       "depth","0.1");
print OUT  <<EOFILE;
Separator {
    Transform {
	translation $half_x $height_tmp 0
	}
EOFILE
&Cube(*def_title12);
print OUT  "\}\n";


########
######## 褳򤫤
########

for ($i = $x_line;$i <= $x;$i++){
    if($i % 31 == 0){
	$i_tmp = $i * $x_times;
    print OUT  "
Separator {
    Transform {
	translation $i_tmp $height_tmp $depth_tmp
	}
    USE YOKOITA
}
"; 
}  
}

########
######## 󤿤Ƥ򤫤
########

for ($i = 1;$i < $day_times;$i++){
    $j = $i * $z_times;
if(($i % 6 == 0)||($i == 23)){
    print OUT  "
Separator {
Transform {
translation $half_x $height_tmp $j
}
USE TATEITA
}
";
}
}

########
######## Xդ񤯡֤Ĥ
########
    foreach $key (keys %day_name){
	if($key % 31 == 0){
	    $key_tmp = $key * $x_times;
	    $z_max_tmp = $z_max + 10;

######## Xդ
%def_text1 = ("DEF","$day_name{$key}",
	     "e_color","1 1 0",
	     "transp","0",
	     "size","5",
	     "family","SANS",
	     "style","BOLD",
	     "string","$day_name{$key}",
	     "spacing","2",
	     "justi","CENTER",
	     "width","30");
print OUT  <<EOFILE;
	    Separator {
		Transform {
		    translation $key_tmp 0 $z_max_tmp
		    }
EOFILE
    &AsciiText(*def_text1);
    print OUT  "\}\n";
	
######## XȤZФƻ֤Ĥ

for ($i = 0;$i < $day_times;$i++){
    $j = $i * $z_times;
if(($i % 6 == 0)||($i == 23)){

%def_text2 = ("DEF","$day_name{$key}_$i",
	     "e_color","1 1 0",
	     "transp","0",
	     "size","$fontsize",
	     "family","SANS",
	     "style","BOLD",
	     "string","$i",
	     "spacing","1",
	     "justi","CENTER",
	     "width","$fontsize");
print OUT  <<EOFILE;
Separator {
    Transform {
	translation $key_tmp $height_tmp_moji $j
	}
EOFILE
    &AsciiText(*def_text2);
    print OUT  "\}\n";
}
}
}
}

########
######## YˤĤ
########
for ($i = 0;$i <= 100 ;$i+=10){
    $j = $i / $y_times; 
%def_text3 = ("DEF","ACCESS_$j",
	     "e_color","1 1 0",
	     "transp","0",
	     "size","$fontsize",
	     "family","SANS",
	     "style","BOLD",
	     "string","$j",
	     "spacing","1",
	     "justi","RIGHT",
	     "width","10");
print OUT  <<EOFILE;
Separator {
    Transform {
	translation -10 $i 0
	}
EOFILE
    &AsciiText(*def_text3);
    print OUT  "\}\n";
}


########
######## ǽ񤭹߽
########

    print OUT  "\}\n";

########
######## ȥץåȥեΥ
########
    close(OUT);
    print "finished.\n";
    print "\t Outputfile is $outputfile\n";

######## 
######## ֥롼
######## 

######## 羮ǥȤ륵֥롼
sub by_number {
    #Subroutine sort by number

    $a <=> $b;
}

######## VRMLեΥإå񤯥֥롼
sub vrml_header {
    #Subroutine vrml_header
    #first, you define "%" which contains title and info.
    #and this subroutine requires the "%".

    local(*titles) = @_;
print OUT  <<EOFILE;
#VRML V1.0 ascii
#    $titles{comment}

    DEF InfoSeparator Separator {
	DEF BackgroundColor Info {
	    string "$titles{background}"
	    }
	DEF Viewer Info {
	    string "$titles{viewer}"
	    }
	DEF Title Info {
	    string "$titles{title}"
	    }
	DEF SceneInfo Info {
	    string "$titles{comment}"
	    }
	DEF ViewerSpeed Info {
	    string "$titles{speed}"
	    }
    }
    DEF Cameras Switch {
        whichChild      -1
        DEF scnene_1 PerspectiveCamera {
            position    -203.97546 291.88983 731.55182
            orientation -0.29819021 -0.94927752 -0.099772975  0.67775357
            focalDistance       879.72076
        }
        DEF scene_2 PerspectiveCamera {
            position    224.13126 40.896004 447.7692
            orientation 0.061973196 0.99803984 -0.008709779  0.27979374
            focalDistance       315.32959
        }
        DEF scene_3 PerspectiveCamera {
            position    196.67712 40.896004 352.02524
            orientation 0.022727532 -0.99970359 0.0087242769  0.73323667
            focalDistance       271.31619
        }
        DEF scene_4 PerspectiveCamera {
            position    172.02583 89.660507 232.58119
            orientation -0.28310317 0.95383549 0.10025212  0.71097082
            focalDistance       197.04701
        }
        DEF home_scene PerspectiveCamera {
            position    418.79999 66.712502 1400.7444
            orientation 0 0 1  0
            focalDistance       1293.2444
            heightAngle 0.78539819
        }
    }
	
EOFILE
}

######## Cube񤯥֥롼
sub Cube {
    #subroutine Cube
    #first, you define "%" which contains title and info.
    #and this subroutine requires the "%".

    local(*titles) = @_;
print OUT  <<EOFILE;
    DEF $titles{DEF} Separator {
	Material {
	    diffuseColor $titles{color}
	    transparency $titles{transp}
	}	    
	Cube {
	    width $titles{width}
	    height $titles{height}
	    depth $titles{depth}
	}
    }
EOFILE
    }

######## Cone񤯥֥롼
sub Cone {
    #subroutine Cone
    #first, you define "%" which contains title and info.
    #and this subroutine requires the "%".

    local(*titles) = @_;
    print OUT  <<EOFILE;
    DEF $titles{DEF} Separator {
	Material {
	    diffuseColor $titles{color}
	    transparency $titles{transp}
	}	    
	Cone {
	    parts $titles{parts}
	    bottomRadius $titles{bradius}
	    height $titles{height}
	}
    }
EOFILE
    }

######## AsciiText & Font (ꤹ)֥롼
sub AsciiText {
    #subroutine AsciiText
    #first, you define "%" which contains title and info.
    #and this subroutine requires the "%".

    local(*titles) = @_;
    print OUT  <<EOFILE;
    DEF _$titles{DEF} Separator {
	Material {
	    emissiveColor $titles{e_color}
	    transparency  $titles{transp}
	}	    
	FontStyle {
	    size $titles{size}
	    family $titles{family}
	    style $titles{style}
	}
	AsciiText {
	    string "$titles{string}"
		spacing $titles{spacing}
	    justification $titles{justi}
	    width $titles{width}
	}
    }
EOFILE
    }

########
######## ǥץཪ
########
exit;

